(import (chicken base) (chicken foreign))

(include "implementations/native/crypt.scm")

;; These all describe what the hash would be of encoding the
;; password "password" with the given salt.
(define types
  `((blowfish "$2a$05$bvIG6Nmid91Mu9RcmmWZfO"
              "$2a$05$bvIG6Nmid91Mu9RcmmWZfO5HJIMCT8riNW0hEp8f6/FuA2/mHZFpe")
    (sha512 "$6$zWwwXKNj"
            ,(string-append "$6$zWwwXKNj$gLAOoZCjcr8p/.VgV/"
                            "FkGC3NX7BsXys3KHYePfuIGMNjY83dVxugPYlxVg/"
                            "evpcVEJLT/rSwZcDMlVVf/bhf.1"))
    (sha256 "$5$MnfsQ4iN"
            "$5$MnfsQ4iN$ZMTppKN16y/tIsUYs/obHlhdP.Os80yXhTurpBMUbA5")
    (md5 "$1$O3JMY.Tw" "$1$O3JMY.Tw$AdLnLjQ/5jXF9.MTp3gHv/")
    (des-extended "_J9..K0Ay" "_J9..K0AyUubDrfOgO4s")
    (des "rE" "rEK1ecacw.7.c")))

(define native-crypt-supported-types
  (foldl (lambda (supported-types type)
           (let* ((name (car type))
                  (feature-name (symbol-append 'crypt-native- name))
                  (salt (cadr type))
                  (hash (caddr type)))
             (if (equal? hash (crypt-native "password" salt))
                 (cons (cons name feature-name) supported-types)
                 supported-types)))
         '()
         types))

;; For the setup script
(with-output-to-file "crypt-features"
  (lambda () (write (map cdr native-crypt-supported-types))))
